package yrpg.application.crmvisit.plugin.form;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.datamodel.events.BizDataEventArgs;
import kd.bos.form.IFormView;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.field.BasedataEdit;
import kd.bos.form.field.events.BeforeF7SelectEvent;
import kd.bos.form.field.events.BeforeF7SelectListener;
import kd.bos.form.operate.FormOperate;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.list.ListShowParameter;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.QueryServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.EventObject;
import java.util.Set;
import java.util.stream.Collectors;

/**
 * 动态表单插件
 */
public class crmVisitDetailFormPlugin extends AbstractFormPlugin implements Plugin {
    @Override
    public void setView(IFormView formView) {
        super.setView(formView);
        System.out.println(formView);
    }

    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);
    }

    @Override
    public void afterCreateNewData(EventObject e) {
        super.afterCreateNewData(e);
        Object visitDate = this.getView().getFormShowParameter().getCustomParam("visitDate");
        if (visitDate != null) {
            this.getModel().setValue("yrpg_appointment_time", visitDate);

        }
    }

    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        super.beforeDoOperation(args);
        FormOperate source = (FormOperate) args.getSource();
        String opKey = source.getOperateKey();
//        if (opKey.equals("submit")) {
//            //提交
//            String text = String.valueOf(this.getModel().getValue("yrpg_textareafield")).trim();
//            if (!text.isEmpty()) {
//                this.getModel().setValue("yrpg_taskstatus", "B");
//                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity()});
//            }
//        } else if (opKey.equals("signin")) {
//            //签到
//            String img_1 = String.valueOf(this.getModel().getValue("yrpg_sign_in_img_2"));
//            String img_2 = String.valueOf(this.getModel().getValue("yrpg_sign_in_img_1"));
//            if (img_1.isEmpty() && img_2.isEmpty()) {
//                args.setCancel(true);
//                this.getView().showTipNotification("请上传签到图片", 3000);
//            } else {
//                this.getModel().setValue("yrpg_taskstatus", "C");
//                this.getModel().setValue("yrpg_sign_in_time", new Date());
//                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity()});
//            }
//        } else if (opKey.equals("signout")) {
//            //签退
//            this.getModel().setValue("yrpg_sign_out_time", new Date());
//            String img_1 = String.valueOf(this.getModel().getValue("yrpg_sign_out_img_1"));
//            String img_2 = String.valueOf(this.getModel().getValue("yrpg_sign_out_img_2"));
//            if (img_1.isEmpty() && img_2.isEmpty()) {
//                args.setCancel(true);
//                this.getView().showTipNotification("请上传签退图片", 3000);
//                return;
//            }
//            Date in_time = (Date) this.getModel().getValue("yrpg_sign_in_time");
//            Date out_time = (Date) this.getModel().getValue("yrpg_sign_out_time");
//            if (in_time != null || out_time != null) {
//                long minutes = (out_time.getTime() - in_time.getTime()) / (60 * 1000);
//                if (minutes < 10) {
//                    args.setCancel(true);
//                    this.getView().showTipNotification("还未到签退时间", 3000);
//                } else {
//                    this.getModel().setValue("yrpg_taskstatus", "D");
//                    SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity()});
//                }
//            } else {
//                args.setCancel(true);
//                this.getView().showTipNotification("请重新定位", 3000);
//            }
//
//        } else if (opKey.equals("summary")) {
//            String summarize = String.valueOf(this.getModel().getValue("yrpg_textareafield1")).trim();
//            if (!summarize.isEmpty()) {
//                this.getModel().setValue("yrpg_taskstatus", "E");
//                SaveServiceHelper.save(new DynamicObject[]{this.getModel().getDataEntity()});
//            } else {
//                args.setCancel(true);
//                this.getView().showTipNotification("请填写总结", 3000);
//            }
//        }
    }

    @Override
    public void createNewData(BizDataEventArgs e) {
        super.createNewData(e);
    }

    @Override
    public void registerListener(EventObject e) {
        super.registerListener(e);
        BasedataEdit expert = this.getView().getControl("yrpg_expert");
        expert.addBeforeF7SelectListener(new BeforeF7SelectListener() {
            @Override
            public void beforeF7Select(BeforeF7SelectEvent f7) {
                String name = f7.getProperty().getName();
                if (name.equals("yrpg_expert")) {
                    ListShowParameter list = (ListShowParameter) f7.getFormShowParameter();
                    QFilter filter = new QFilter("billstatus", QCP.equals, "C");
                    filter.and("entryentity.yrpg_maintainer.id", QCP.equals, RequestContext.get().getCurrUserId());
                    DynamicObjectCollection expertColl = QueryServiceHelper.query("yrpg_relationship_bind", "yrpg_expert_name", filter.toArray());
                    Set<Long> expertId = expertColl.stream().map(x -> x.getLong("yrpg_expert_name")).collect(Collectors.toSet());
                    QFilter filter_1 = new QFilter("id", QCP.in, expertId);
                    list.getListFilterParameter().setFilter(filter_1);
                }
            }
        });
    }

}
