package yrpg.application.crmvisit.plugin.form;

import com.alibaba.fastjson.JSONObject;
import kd.bos.ext.form.control.CustomControl;
import kd.bos.form.events.CustomEventArgs;
import kd.bos.form.plugin.AbstractFormPlugin;

import java.util.Date;
import java.util.EventObject;
import java.util.HashMap;
import java.util.Map;

/**
 * 单据界面插件(移动端)
 */
public class setLocationFormPlugin extends AbstractFormPlugin {

    private static final String SIGN_IN_TYPE = "signIn";
    private static final String SIGN_OUT_TYPE = "signOut";


    @Override
    public void afterBindData(EventObject e) {
        super.afterBindData(e);

        CustomControl customControlSignIn = this.getView().getControl("yrpg_customcontrolap");
        Map<String, Object> paramsMapSignIn = new HashMap<String, Object>(1);
        paramsMapSignIn.put("targetAddress", "泰州市高港区海燕大酒店");
        customControlSignIn.setData(paramsMapSignIn);
        CustomControl customControlSignOut = this.getView().getControl("yrpg_customcontrolap1");
        Map<String, Object> paramsMapSignOut = new HashMap<String, Object>(1);
        paramsMapSignOut.put("targetAddress", "泰州市高港区海燕大酒店");
        customControlSignOut.setData(paramsMapSignOut);
    }

    @Override
    public void customEvent(CustomEventArgs e) {
        // 设计器上自定义控件的标识
        String key = e.getKey();
        // 前端通过model.invoke传给后端的数据
        String args = e.getEventArgs();
        // 前端通过model.invoke定义的事件名
        String eventName = e.getEventName();
        System.out.println("自定义控件标识: " + key + ";事件名: " + eventName + ";自定义控件回传参数: " + args);
        // this.getView().showMessage("自定义控件标识: " + key + ";事件名: " + eventName + ";自定义控件回传参数: " + args);

        System.out.println(args);
        JSONObject jsonObj = JSONObject.parseObject(args);
        String type = jsonObj.getString("type");
        String address = jsonObj.getString("address");
        String lngLat = jsonObj.getString("lng") + "," + jsonObj.getString("lat");
        Boolean within = jsonObj.getBoolean("within");


        if (SIGN_IN_TYPE.equals(type)) {
            this.getModel().setValue("yrpg_sign_in_address", address);
            this.getModel().setValue("yrpg_sign_in_lat", lngLat);
            this.getModel().setValue("yrpg_sign_in_within", within ? "是" : "否");
//            this.getModel().setValue("yrpg_sign_in_time", new Date());
        } else if (SIGN_OUT_TYPE.equals(type)) {
            this.getModel().setValue("yrpg_sign_out_address", address);
            this.getModel().setValue("yrpg_sign_out_lat", lngLat);
            this.getModel().setValue("yrpg_sign_out_within", within ? "是" : "否");
//            this.getModel().setValue("yrpg_sign_out_time", new Date());
        }


    }

}